/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * Price
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Price {
  @SerializedName("formula")
  private String formula = null;

  @SerializedName("total_taxes")
  private BigDecimal totalTaxes = null;

  @SerializedName("premium_before_discount_excl_tax")
  private BigDecimal premiumBeforeDiscountExclTax = null;

  @SerializedName("price_after_discount_incl_tax")
  private BigDecimal priceAfterDiscountInclTax = null;

  public Price formula(String formula) {
    this.formula = formula;
    return this;
  }

   /**
   * Price formula reference.
   * @return formula
  **/
  @ApiModelProperty(example = "24-MONTH", required = true, value = "Price formula reference.")
  public String getFormula() {
    return formula;
  }

  public void setFormula(String formula) {
    this.formula = formula;
  }

  public Price totalTaxes(BigDecimal totalTaxes) {
    this.totalTaxes = totalTaxes;
    return this;
  }

   /**
   * Total amount of taxes, numeric with 2 decimals.
   * @return totalTaxes
  **/
  @ApiModelProperty(example = "50.1", value = "Total amount of taxes, numeric with 2 decimals.")
  public BigDecimal getTotalTaxes() {
    return totalTaxes;
  }

  public void setTotalTaxes(BigDecimal totalTaxes) {
    this.totalTaxes = totalTaxes;
  }

  public Price premiumBeforeDiscountExclTax(BigDecimal premiumBeforeDiscountExclTax) {
    this.premiumBeforeDiscountExclTax = premiumBeforeDiscountExclTax;
    return this;
  }

   /**
   * Premium not discounted excluding taxes, numeric with 2 decimals.
   * @return premiumBeforeDiscountExclTax
  **/
  @ApiModelProperty(example = "150.2", value = "Premium not discounted excluding taxes, numeric with 2 decimals.")
  public BigDecimal getPremiumBeforeDiscountExclTax() {
    return premiumBeforeDiscountExclTax;
  }

  public void setPremiumBeforeDiscountExclTax(BigDecimal premiumBeforeDiscountExclTax) {
    this.premiumBeforeDiscountExclTax = premiumBeforeDiscountExclTax;
  }

  public Price priceAfterDiscountInclTax(BigDecimal priceAfterDiscountInclTax) {
    this.priceAfterDiscountInclTax = priceAfterDiscountInclTax;
    return this;
  }

   /**
   * Price discounted including taxes (Final price), numeric with 2 decimals.
   * @return priceAfterDiscountInclTax
  **/
  @ApiModelProperty(example = "250.3", required = true, value = "Price discounted including taxes (Final price), numeric with 2 decimals.")
  public BigDecimal getPriceAfterDiscountInclTax() {
    return priceAfterDiscountInclTax;
  }

  public void setPriceAfterDiscountInclTax(BigDecimal priceAfterDiscountInclTax) {
    this.priceAfterDiscountInclTax = priceAfterDiscountInclTax;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Price price = (Price) o;
    return Objects.equals(this.formula, price.formula) &&
        Objects.equals(this.totalTaxes, price.totalTaxes) &&
        Objects.equals(this.premiumBeforeDiscountExclTax, price.premiumBeforeDiscountExclTax) &&
        Objects.equals(this.priceAfterDiscountInclTax, price.priceAfterDiscountInclTax);
  }

  @Override
  public int hashCode() {
    return Objects.hash(formula, totalTaxes, premiumBeforeDiscountExclTax, priceAfterDiscountInclTax);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Price {\n");
    
    sb.append("    formula: ").append(toIndentedString(formula)).append("\n");
    sb.append("    totalTaxes: ").append(toIndentedString(totalTaxes)).append("\n");
    sb.append("    premiumBeforeDiscountExclTax: ").append(toIndentedString(premiumBeforeDiscountExclTax)).append("\n");
    sb.append("    priceAfterDiscountInclTax: ").append(toIndentedString(priceAfterDiscountInclTax)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

